<!doctype html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>Product Request Form</title>
    <style type="text/css">
        label {
            font: 13px "Lucida Sans Unicode", "Lucida Grande", sans-serif;
            font-weight: bold;
            color: #e6b5de;
        }

        fieldset {
            font: 15px "Lucida Sans Unicode", "Lucida Grande", sans-serif;
            font-weight: bold;
            color: #e6b5de;
        }
    </style>
</head>
<body style="background-color: #ecece3;">

<?php
include('mysqli_connect.php');

// Check if form fields are submitted
if (!empty($_POST['firstname']) && !empty($_POST['lastname']) && !empty($_POST['username']) && !empty($_POST['password'])) {
    $firstname = trim($_POST['firstname']);
    $lastname  = trim($_POST['lastname']);
    $username  = trim($_POST['username']);
    $password  = $_POST['password'];

    // Check if username already exists
    // aditional resourse used to check if username is already in use. https://www.php.net/manual/en/mysqli-stmt.bind-param.php and https://www.w3schools.com/php/php_mysql_prepared_statements.asp
    $checkQuery = "SELECT id FROM users WHERE username = ?";
    $query = mysqli_prepare($dbc, $checkQuery);
    mysqli_stmt_bind_param($query, "s", $username);
    mysqli_stmt_execute($query);
    mysqli_stmt_store_result($query);

    if (mysqli_stmt_num_rows($query) > 0) {
        // Username taken
        echo "<h1 style='text-align: center; color: #e6b5de;'>Username already taken. Please choose another.</h1>";
        
        echo '<p style="text-align: center;"><button type="button" onclick="location.href=\'signup_form.php\'">Back to Sign Up</button></p>';


        mysqli_stmt_close($query);
    } else {
        // Username is available, proceed with insertion
        mysqli_stmt_close($query);

        // Hash the password
        $hashedPassword = hash('sha256', $password);

        // Insert the new user using the hashed password
        $query1 = "INSERT INTO users (firstname, lastname, username, password) VALUES ('$firstname', '$lastname', '$username', '$hashedPassword')";
        $result = mysqli_query($dbc, $query1);

        if ($result) {
            // Success message
            echo "<h1 style='text-align: center; color: #e6b5de;'>Sign up successful!";
            echo "<br><br><br>";
            
            echo "<p><button type=\"button\" onclick=\"location.href='login_form.php'\">Login</button></p>";
        } else {
            // Something went wrong with the insert
            echo "<p style='color:#e6b5de; text-align:center;'>There was an issue creating your account. Please try again.</p>";
            
            echo "<p><button type=\"button\" onclick=\"location.href='signup_form.php'\">Back to Sign Up</button></p>";
        }
    }
} else {
    // Missing fields
    echo "<p style='color:#e6b5de; text-align:center;'>Please fill in all required fields.</p>";
    
    echo "<p><button type=\"button\" onclick=\"location.href='signup_form.php'\">Back to Sign Up</button></p>";
}
?>

</body>
</html>
